//+------------------------------------------------------------------+
//|                                                                  |
//|                                                   JATIN PATEL    |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Jatin PATEL"


#include <Trade\Trade.mqh>
#include <Trade\PositionInfo.mqh> //include the library for obtaining information on

#include "MySignal.mqh"
MqlTradeRequest trequest; // MQL5 trade request structure to be used for sending our trade requests
MqlTradeResult tresult; // MQL5 trade result structure to be used to get our trade results

CPositionInfo m_Position; // structure for obtaining information of positions
CTrade trade;

input double Lot = 0.01; // Lots to Trade
input double PROFIT = 5; //Profit use > 0 if you  want to use
input double PARSIAL_PROFIT = 1 ; // ONLY WORK WHEN PROFIT < 0
input double STOP_LOSS = -20 ; // ONLY WORK WHEN PROFIT < 0
input bool IS_USE_SIGNAL = true;
input double Trd_percent = 45.0; // Percentage of Free Margin To use for Trading
input int MAXIMUM_NOT_NONE_SIGNAL = 2 ; // maximum none signal
input ENUM_TIMEFRAMES CUR_PERIOD = PERIOD_CURRENT; // Time
input int EA_Magic = 2847; // Lots to Trade

MySignal mySignal[3];
//buy sell sell
string symbol_array[3] = {"EURTRY", "TRYJPY", "EURJPY"};

int OnInit()
{
 for(int i = 0 ; i< 3 ;i++){
	 mySignal[i].MY_PERIOD = CUR_PERIOD;
	 mySignal[i].MY_SYMBOL = symbol_array[i];
	 mySignal[i].inIT();
 }
  EventSetTimer(1); // 1 second
}

void OnDeinit(const int reason)
{
    ZeroMemory(trequest);
    ZeroMemory(tresult);
    //--- Termination of event generation
    EventKillTimer();
    //--- Run UnIntilialize function
    for (int i = 0; i < 3; i++) {
        mySignal[i].deInit();
    }
}

void OnTimer()
{
    int dayOfWeek = DayOfWeek();
    if (dayOfWeek == 0 || dayOfWeek == 6) {
        Sleep(900000); // 15 min
        return;
    }
    
    if (countTotalOpenOrder() > 0) // FUTURE DEVELOPMENT : ALL ORDERS ARE OPEN OR NOT
    {
		 if(calculateProfit() < STOP_LOSS){
			closeAllOrder();
			return;
		 }
		if(  PROFIT > 0  ){
			if(calculateProfit() > PROFIT)
			closeAllOrder();
		}else{
			if(calculateProfit() > PARSIAL_PROFIT){
				if(!checkSignal()){
				  closeAllOrder();
			   }
			}
		}
		return ;
	}else{
			if (!MarginOK()) {
				return;
			}
		if(IS_USE_SIGNAL){
			if(checkSignal()){
				placeOrder();
			}
		}else{
			placeOrder();
		}
	}  
}
// BUY_COUNT =0 ; SELL_COUNT = 0 ; NULL_COUNT = 0 ;
bool checkSignal(){
	//buy
		  mySignal[0].signal();
		  if(mySignal[0].NULL_COUNT < MAXIMUM_NOT_NONE_SIGNAL )
			  return false;
		  if( mySignal[0].SELL_COUNT >= mySignal[0].BUY_COUNT)
			  return false;
	//sell	  
		  mySignal[1].signal();
		  if(mySignal[1].NULL_COUNT < MAXIMUM_NOT_NONE_SIGNAL )
			  return false;
		  if( mySignal[1].BUY_COUNT >= mySignal[1].SELL_COUNT)
			  return false;
    //sell
			mySignal[2].signal();
		  if(mySignal[2].NULL_COUNT < MAXIMUM_NOT_NONE_SIGNAL )
			  return false;
		   if( mySignal[2].BUY_COUNT >= mySignal[2].SELL_COUNT)
			  return false;
		  
		return true;  
}

void placeOrder(){
	openBuySell(ORDER_TYPE_BUY,symbol_array[0]);
	openBuySell(ORDER_TYPE_SELL,symbol_array[1]);
	openBuySell(ORDER_TYPE_SELL,symbol_array[2]);
}

bool openBuySell(ENUM_ORDER_TYPE otype, string symbol)
{

    bool result = false;
    double oprice = 0, stl = 0, tkp = 0, ask = 0, bid = 0;
    MqlTick latest_price;
    bool bidask = false;
    if (SymbolInfoTick(symbol, latest_price)) {
        bidask = true;
    }
    int digits = (int)SymbolInfoInteger(symbol, SYMBOL_DIGITS); // number of decimal places
    double nPoint = SymbolInfoDouble(symbol, SYMBOL_POINT);
    if (otype == ORDER_TYPE_BUY) {
        ask = bidask ? latest_price.ask : SymbolInfoDouble(symbol, SYMBOL_ASK);
        oprice = NormalizeDouble(ask, digits); // current Ask price
        // stl = NormalizeDouble(ask - STP * nPoint, digits); // Stop Loss
        // tkp = NormalizeDouble(ask + TKP * nPoint, digits); // Take profit
    }
    else if (otype == ORDER_TYPE_SELL) {
        bid = bidask ? latest_price.bid : SymbolInfoDouble(symbol, SYMBOL_BID);
        oprice = NormalizeDouble(bid, digits); // Current Bid price
        // stl = NormalizeDouble(bid + STP * nPoint, digits); // Stop Loss
        // tkp = NormalizeDouble(bid - TKP * nPoint, digits); // Take Profit
    }
    else {
        Print("Invalid Order Type");
        return result;
    }

    trequest.action = TRADE_ACTION_DEAL;
    trequest.type = otype;
    trequest.volume = Lot;
    trequest.price = oprice;
    trequest.sl = 0;
    trequest.tp = 0;
    trequest.deviation = 1000;
    trequest.magic = EA_Magic;
    trequest.symbol = symbol;
    trequest.type_filling = ORDER_FILLING_FOK;
    trequest.comment = "OM NAMAH SIVAY";
    OrderSend(trequest, tresult);
    if (tresult.retcode == 10009 || tresult.retcode == 10008) // Request successfully completed
    {
        result = true;
       // Print("A Buy order has been successfully placed with Ticket#:", tresult.order, "!!");
    }
    else {
        result = false;
        Print("The Buy order request could not be completed#:", GetLastError(), "!!");
    }
    return result;
}


double calculateProfit()
{
    return AccountInfoDouble(ACCOUNT_PROFIT);
}

int countTotalOpenOrder()
{
    int total = PositionsTotal();
    return (total);
}
void closeAllOrder()
{
    for (int i = PositionsTotal() - 1; i >= 0; i--) {
        {
            if (!trade.PositionClose(PositionGetTicket(i))) {
                Print(PositionGetSymbol(i), "PositionClose() method failed. Return code=", trade.ResultRetcode(), ". Code description: ", trade.ResultRetcodeDescription()); //--- failure message
            }
        }
    }
}

bool MarginOK()
{
    double one_lot_price; // Margin required for one lot
    double act_f_mag = AccountInfoDouble(ACCOUNT_FREEMARGIN); // Account free margin
    long levrage = AccountInfoInteger(ACCOUNT_LEVERAGE); // Leverage for this account
    double contract_size = SymbolInfoDouble("EURTRY", SYMBOL_TRADE_CONTRACT_SIZE); // Total units for one lot
    string base_currency = SymbolInfoString("EURTRY", SYMBOL_CURRENCY_BASE); // Base currency for currency pair
    //
    if (base_currency == "USD") {
        one_lot_price = contract_size / levrage;
    }
    else {
        double bprice = SymbolInfoDouble("EURTRY", SYMBOL_BID);
        one_lot_price = bprice * contract_size / levrage;
    }
    // Check if margin required is okay based on setting
    if (MathFloor(Lot * one_lot_price * 3) > MathFloor(act_f_mag * Trd_percent)) {
        return (false);
    }
    else {
        return (true);
    }
}


